ShamanWarning = LibStub("AceAddon-3.0"):NewAddon("Shaman Warning", "AceEvent-3.0", "AceConsole-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("ShamanWarning", true);

local function getOption(info)
	return (info.arg and ShamanWarning.db.profile[info.arg] or ShamanWarning.db.profile[info[#info]]);
end;

local function setOption(info, value)
	local key = info.arg or info[#info];
	ShamanWarning.db.profile[key] = value;
	--ShamanWarning:UpdateFrame() --
end;

local options = {
	name = "ShamanWarning",
	type = "group",
	childGroups = "tab",
	args = {
		check = {
			name = "Check",
			hidden = true,
			type = "execute",
			func = "CheckTrinket",
		},
		elemental = {
			name = "Element",
			desc = L["Elemental"],
			type = "group",
			order = 1,
			args = {
				elemental = {
					name = L["Elemental Devastation"],
					desc = L["Toggles on/off Elemental Devastation proc warning"],
					order = 3,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				clearcast = {
					name = L["Clearcasting"],
					desc = L["Toggles on/off Clearcasting proc warning"],
					order = 2,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
			},
		},
		enhancement = {
			name = "Enhance",
			desc = L["Enhancement"],
			type = "group",
			order = 2,
			args = {
				flurry = {
					name = L["Flurry"],
					desc = L["Toggles on/off Flurry proc warning"],
					order = 1,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				maelstrom = {
					name = L["Maelstrom"],
					desc = L["Toggles on/off Maelstrom proc warning"],
					order = 3,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
			},
		},
		restoration = {
			name = "Resto",
			desc = L["Restoration"],
			type = "group",
			order = 3,
			args = {
				earthshield = {
					name = L["Earth Shield"],
					desc = L["Toggles on/off Earth Shield removed warning"],
					order = 2,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				manatide = {
					name = L["Mana Tide Totem"],
					desc = L["Toggles on/off Mana Tide Totem warning"],
					order = 3,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				ancestral = {
					name = L["Ancestral Awakening"],
					desc = L["Toggles on/off Ancestral Awakening warning"],
					order = 1,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				tidal = {
					name = L["Tidal Waves"],
					desc = L["Toggles on/off Tidal Waves warning"],
					order = 4,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
			},
		},
		
		items = {
			name = L["Totem/Trinket"],
			desc = L["Totem/Trinket procs"],
			type = "group",
			order = 5,
			args = {
				totem_active = {
					name = L["Totem Warning"],
					desc = L["Toggles ON/OFF totem proc warning"],
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				trinket_1_active = {
					name = L["Trinket Warning"].." #1",
					desc = L["Toggles ON/OFF trinket proc warning"],
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				trinket_2_active = {
					name = L["Trinket Warning"].." #2",
					desc = L["Toggles ON/OFF trinket proc warning"],
					type = "toggle",
					get = getOption,
					set = setOption,
				},
			},
		},
							
		misc = {
			name = "Misc",
			desc = L["Misc spells"],
			type = "group",
			order = 10,
			args = {
				windfury = {
					name = L["Windfury"],
					desc = L["Toggles on/off Windfury proc warning"],
					order = 5,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				water = {
					name = L["Water Shield"],
					desc = L["Toggles on/off Water Shield removed warning"],
					order = 4,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				lightning = {
					name = L["Lightning Shield"],
					desc = L["Toggles on/off Lightning Shield removed warning"],
					order = 2,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				executioner = {
					name = L["Executioner"],
					desc = L["Toggles on/off Executioner proc warning"],
					order = 1,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
				mongoose = {
					name = L["Mongoose"],
					desc = L["Toggles on/off Mongoose proc warning"],
					order = 3,
					type = "toggle",
					get = getOption,
					set = setOption,
				},
			},
		},
	},
};

local defaults = {
	profile = {
		elemental = true,
		windfury = true,
		flurry = true,
		maelstrom = true,
		water = true,
		clearcast = true,
		executioner = true,
		mongoose = true,
		invigorated = true,
		charged = true,
		wavetrance = true,
		earthshield = true,
		lightning = true,
		manatide = true,
		ancestral = true,
		tidal = true,
		totem_active = false,
		totem_name = "",
		totem_proc = "",
		trinket_1_active = false,
		trinket_1_name = "",
		trinket_1_proc = "",
		trinket_2_active = false,
		trinket_2_name = "",
		trinket_2_proc = ""
	},
};

local totem_list = {
	[L["Bizuri's Totem of Shattered Ice"]] = L["Furious"],
	[L["Totem of the Avalanche"]] = L["Enraged"],
	[L["Totem of the Surging Sea"]] = L["Energized"],
	[L["Totem of Calming Tides"]] = L["Spiritual Trance"],
	[L["Totem of Electrifying Wind"]] = L["Energized"],
	[L["Totem of Quaking Earth"]] = L["Volcanic Fury"],
	[L["Totem of the Elemental Plane"]] = L["Totem of the Elemental Plane"]
	-- [L[""]] = L[""],
};

local trinket_list = {
	[L["Dying Curse"]] = L["Dying Curse"],
	[L["Sundial of the Exiled"]] = L["Now is the time!"],
	[L["Hourglass of the Unraveller"]] = L["Rage of the Unraveller"],
	[L["Scarab of the Infinite Cycle"]] = L["Spell Haste"],
	[L["Shiffar's Nexus-Horn"]] = L["Call of the Nexus"],
	[L["Sonic Booster"]] = L["Sonic Awareness"],
	[L["Forge Ember"]] = L["Forge Ember"],
	[L["Meteorite Whetstone"]] = L["Meteorite Whetstone"],
	[L["Shard of Contempt"]] = L["Disdain"],
	[L["Dragonspine Trophy"]] = L["Dragonspine Flurry"],
	[L["Eye of Magtheridon"]] = L["Recurring Power"],
	[L["Sextant of Unstable Currents"]] = L["Unstable Currents"],
	[L["Tsunami Talisman"]] = L["Fury of the Crashing Waves"],
	[L["Death Knight's Anguish"]] = L["Wracking Pains"],
	[L["Serrah's Star"]] = L["Star of Light"],
	[L["Madness of the Betrayer"]] = L["Forceful Strike"],
	[L["Valonforth's Remembrance"]] = L["Purified Spirit"],
	[L["Blackened Naaru Sliver"]] = L["Battle Trance"],
	[L["Chuchu's Tiny Box of Horrors"]] = L["Tentacles"],
	[L["Crusader's Locket"]] = L["Crusader's Glory"],
	[L["Anvil of Titans"]] = L["Reflection of Torment"],
	[L["Darkmoon Card: Greatness"]] = L["Darkmoon Card: Greatness"],
	[L["Embrace of the Spider"]] = L["Embrace of the Spider"],
	[L["Flow of Knowledge"]] = L["Now is the time!"],
	[L["Mirror of Truth"]] = L["Reflection of Torment"],
	[L["Tears of Bitter Anguish"]] = L["Tears of Anguish"],
	[L["The Egg of Mortal Essence"]] = L["Essence of Life"],
	[L["Grim Toll"]] = L["Grim Toll"],
	[L["Althor's Abacus"]] = L["Echoes of Light"],
	[L["Corpse Tongue Coin"]] = L["Thick Skin"],
	[L["Dislodged Foreign Object"]] = L["Surge of Power"],
	[L["Phylactery of the Nameless Lich"]] = L["Siphoned Power"],
	[L["Purified Lunar Dust"]] = L["Revitalized"],
	[L["Whispering Fanged Skull"]] = L["Icy Rage"],
	-- [L[""]] = L[""],
};

function ShamanWarning:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ShamanWarningDB", defaults, "Default");
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ShamanWarning", options);
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ShamanWarning", "ShamanWarning");
	self:RegisterChatCommand("ShamanWarning", "ChatCommand");
	self:RegisterChatCommand("shw", "ChatCommand");
end;

function ShamanWarning:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","CombatLogEvent");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED","CheckItems");
	self:RegisterEvent("PLAYER_ENTERING_WORLD","CheckItems");
	self:RegisterEvent("UNIT_AURA","ScanBuff");
end;

function ShamanWarning:ChatCommand(input)
    if not input or input:trim() == "" then
		self:CheckItems("SW");
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame);
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(ShamanWarning, "ShamanWarning", "ShamanWarning", input);
    end
end

function ShamanWarning:CombatLogEvent(a, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName)
	if event=="SPELL_AURA_APPLIED" and destFlags==0x511 then
		if spellName==L["Flurry"] and self.db.profile.flurry then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Flurry.mp3");
		end;
		if (spellName==L["Clearcasting"] or spellName=="Focused") and self.db.profile.clearcast then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Clearcast.mp3");
		end;
		if spellName==L["Elemental Devastation"] and self.db.profile.elemental then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Elemental.mp3");
		end;
		if spellName==L["Lightning Speed"] and self.db.profile.mongoose then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Lightning.mp3");
		end;
		if spellName==L["Executioner"] and self.db.profile.executioner then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Executioner.mp3");
		end;
		if spellName==L["Tidal Waves"] and self.db.profile.tidal then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Tidal.mp3");
		end;
		
		-- Totem warnings
		if spellName==self.db.profile.totem_proc and self.db.profile.totem_active then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Power.mp3");
		end;
	end;
	if event=="SPELL_AURA_REMOVED" and destFlags==0x511 then
		if spellName==L["Water Shield"] and self.db.profile.water then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Water.mp3");
		end;
		if spellName==L["Earth Shield"] and self.db.profile.earthshield then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Earth.mp3");
		end;
		if spellName==L["Lightning Shield"] and self.db.profile.lightning then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Light.mp3");
		end;
	end;
	if event=="SPELL_DAMAGE" and sourceFlags==0x511 then
		if spellName==L["Windfury Attack"] and self.db.profile.windfury then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\WindFury.mp3");
		end;
	end;
	if event=="SPELL_SUMMON" then
		if spellName==L["Mana Tide Totem"] and self.db.profile.manatide then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\ManaTide.mp3");
		end;
	end;
	if event=="SPELL_HEAL" and sourceFlags==0x511 then
		if spellName==L["Ancestral Awakening"] and self.db.profile.ancestral then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Power.mp3");
		end;
	end;
	
	-- Trinket warnings
	if event=="SPELL_ENERGIZE" or event=="SPELL_AURA_APPLIED" and sourceFlags==0x511 then
		if self.db.profile.trinket_1_name~=nil and spellName==self.db.profile.trinket_1_name and self.db.profile.trinket_1_active then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Bell.mp3");
		end;
		if self.db.profile.trinket_2_name~=nil and spellName==self.db.profile.trinket_2_name and self.db.profile.trinket_2_active then
			PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Bell.mp3");
		end;
	end;

end;

function ShamanWarning:ScanBuff(n,ID)
	if ID == "player" then
		for i=1,40 do
			local b_Name,_,_,b_Count,_,_,_,_,_ = UnitAura(ID,i);
			if b_Name ~= nil and b_Count ~= nil and string.find(b_Name,L["Maelstrom"]) then
				if b_Count == 5 then
					PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Maelstrom.mp3");
				end;
			end;
		end;
	end;
end;

function ShamanWarning:CheckItems(test)
	self:CheckTotem(test);
	self:CheckTrinket(13, test);
	self:CheckTrinket(14, test);
end;

function ShamanWarning:CheckTotem(test)
	-- Check totem
	local totemLink, totemName;
	if GetInventoryItemLink("player",18) ~= nil then
		totemLink = GetInventoryItemLink("player",18);
		totemName, _, _, _, _, _, _, _, _, _, _ = GetItemInfo("\""..totemLink.."\"");
		local found = 0;
		-- Get proc
		for k,v in pairs(totem_list) do
			if totemName ~= nil and v ~= nil and totemName == k then
				self.db.profile.totem_name = totemName;
				self.db.profile.totem_proc = v;
				found = 1;
			end;
		end;
		-- Found?
		if found == 0 and test == "SW" then
			ShamanWarning:Print("Equiped totem doesnt have proc or is not supported");
		end;
	end;
end;

function ShamanWarning:CheckTrinket(trinket_num, test)
	-- Check trinkets
	local trinketLink, trinketName;
	if GetInventoryItemLink("player",trinket_num) ~= nil then
		trinketLink = GetInventoryItemLink("player",trinket_num);
		trinketName, _, _, _, _, _, _, _, _, _, _ = GetItemInfo("\""..trinketLink.."\"");
		local found = 0;
		-- Get proc
		for k,v in pairs(trinket_list) do
			if trinketName ~= nil and v ~= nil and trinketName == k then
				if trinket_num == 13 then
					self.db.profile.trinket_1_name = trinketName;
					self.db.profile.trinket_1_proc = v;
				end;
				if trinket_num == 14 then
					self.db.profile.trinket_2_name = trinketName;
					self.db.profile.trinket_2_proc = v;
				end;
				found = 1;
			end;
		end;
		-- Found?
		if found == 0 and test == "SW" then
			if trinket_num == 13 then
				ShamanWarning:Print("First trinket doesnt have proc or is not supported");
			end;
			if trinket_num == 14 then
				ShamanWarning:Print("Second trinket doesnt have proc or is not supported");
			end;
		end;
	end;
end;



-- Debug functions --
function ShamanWarning:PTR(name,data)
	if data ~= nil then
		ShamanWarning:Print(name..": "..data);
	else
		ShamanWarning:Print(name..": nil");
	end;
end;
